//+------------------------------------------------------------------+
//| v.18.08.08 |                                      DC_Channel.mq4 |
//|            |              Bookkeeper, 2008, yuzefovich@gmail.com |
//+------------+-----------------------------------------------------+
//   : http://xrust.ucoz.net/forum/8-21-1
//
//    ISC.mq4 v.16.08.08
//  Presence ISC.mq4 v.16.08.08 is necessary 
//    IMA.mq4 v.16.08.08
//  Presence IMA.mq4 v.16.08.08 is necessary 
//    OsIEMA_Channel.mq4 v.16.08.08
//  Presence OsIEMA_Channel.mq4 v.16.08.08 is necessary 
//    IRSI_Channel.mq4 v.16.08.08
//  Presence IRSI_Channel.mq4 v.16.08.08 is necessary 
//    Turbo_JRSX.mq4
//  Presence Turbo_JRSX.mq4 is necessary 
//    OsTJRSX_Channel.mq4 v.31.08.08
//  Presence OsTJRSX_Channel.mq4 v.31.08.08 is necessary 
/*-------------------------------------------------------------------+
   
    ,     :)
   
       ,  ,    
    :
   1.  :
   1.1.          
     Forex (    ).
   1.2.       
            (
      )     Forex (
      ).
   1.3.  (   )    
        ,   
       .
   2.   :
   2.1.          
     ,  ,    1.1
    1.2.
   2.2.  (        ex4-)
          (     ).
   
    :)   !      !
         -   ,  .
            
   ,    ,    .

                                                        Bookkeeper

  +-----------------------------------------------------------------*/
#property  copyright ""
#property  link      ""
#property indicator_chart_window
#property  indicator_buffers 6
#property  indicator_color1  Red
#property  indicator_color2  Green
#property  indicator_color3  Green
#property  indicator_color4  Red
#property  indicator_color5  Green
#property  indicator_color6  Red
extern int SwitchDC=0; // 0: Chart-OsIEMA
                       // 1: Chart-IRSI
                       // 2: Chart-OsTJRSX
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern int RSIPeriod=14;
extern int FastJRSX=12;
extern int SlowJRSX=26;
extern int SignalJRSX=9;
double     UpUnits[];
double     DnUnits[];
double     Up1[];
double     Dn1[];
double     Up0[];
double     Dn0[];

//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_SECTION);//,EMPTY,2);//
   SetIndexStyle(1,DRAW_SECTION);//,EMPTY,2);//
   SetIndexStyle(2,DRAW_ARROW,EMPTY,1);//NONE);//
   SetIndexStyle(3,DRAW_ARROW,EMPTY,1);//NONE);//
   SetIndexStyle(4,DRAW_ARROW,EMPTY,1);//NONE);//
   SetIndexStyle(5,DRAW_ARROW,EMPTY,1);//NONE);//
   SetIndexBuffer(0,UpUnits);
   SetIndexBuffer(1,DnUnits);
   SetIndexBuffer(2,Up1);
   SetIndexBuffer(3,Dn1);
   SetIndexBuffer(4,Up0);
   SetIndexBuffer(5,Dn0);
   SetIndexArrow(2,233); 
   SetIndexArrow(3,234); 
   SetIndexArrow(4,241); 
   SetIndexArrow(5,242); 
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
   return(0);
  }
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   limit=MathMax(limit,5);
   int j=limit-1;
   for(int i=limit; i>0; i--)
   {
      UpUnits[i]=0;
      DnUnits[i]=0;
      Up1[i]=0;
      Dn1[i]=0;
      Up0[i]=0;
      Dn0[i]=0;
      switch (SwitchDC)
      {
         case 0:
           if(iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,1,i)!=0)
                UpUnits[i]=High[iHighest(NULL,0,MODE_HIGH,3,i-1)];
           if(iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,2,i)!=0)
                DnUnits[i]=Low[iLowest(NULL,0,MODE_LOW,3,i-1)];
           break;
         case 1:
           if(iCustom(NULL,0,"IRSI_Channel",RSIPeriod,1,i)!=0)
                UpUnits[i]=High[iHighest(NULL,0,MODE_HIGH,3,i-1)];
           if(iCustom(NULL,0,"IRSI_Channel",RSIPeriod,2,i)!=0)
                DnUnits[i]=Low[iLowest(NULL,0,MODE_LOW,3,i-1)];
           break;
         case 2:
           if(iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,1,i)!=0)
                UpUnits[i]=High[iHighest(NULL,0,MODE_HIGH,3,i-1)];
           if(iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,2,i)!=0)
                DnUnits[i]=Low[iLowest(NULL,0,MODE_LOW,3,i-1)];
           break;
         default:
           if(iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,1,i)!=0)
                UpUnits[i]=High[iHighest(NULL,0,MODE_HIGH,3,i-1)];
           if(iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,2,i)!=0)
                DnUnits[i]=Low[iLowest(NULL,0,MODE_LOW,3,i-1)];
           break;
      }
   }
   UpUnits[0]=High[0];
   DnUnits[0]=Low[0];
   i=j;
   double Dchart, Dseparate, osc2, oscj;
   while(i>=0)
   {
      if(UpUnits[i+1]!=0)
      {
         j=i+2;
         while(UpUnits[j]==0 && j<Bars-SlowEMA) j++;
         if(UpUnits[j]!=0)
         {
            
            Dchart=UpUnits[i+1]-UpUnits[j];
            switch (SwitchDC)
            {
               case 0:
                  osc2=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,i+1);
                  oscj=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,j);
                  break;
               case 1:
                  osc2=iCustom(NULL,0,"IRSI_Channel",RSIPeriod,0,i+1);
                  oscj=iCustom(NULL,0,"IRSI_Channel",RSIPeriod,0,j);
                  break;
               case 2:
                  osc2=iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,0,i+1);
                  oscj=iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,0,j);
                  break;
               default:
                  osc2=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,i+1);
                  oscj=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,j);
                  break;
            }
            Dseparate=osc2-oscj;
            if((Dchart>0 && Dseparate<0) || (Dchart<0 && Dseparate>0))
            {
               if(i==0) Dn0[i+1]=UpUnits[i+1];
               else Dn1[i+1]=UpUnits[i+1];
            }
         }
      }
      if(DnUnits[i+1]!=0)
      {
         j=i+2;
         while(DnUnits[j]==0 && j<Bars-SlowEMA) j++;
         if(DnUnits[j]!=0)
         {
            Dchart=DnUnits[i+1]-DnUnits[j];
            switch (SwitchDC)
            {
               case 0:
                  osc2=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,i+2);
                  oscj=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,j);
                  break;
               case 1:
                  osc2=iCustom(NULL,0,"IRSI_Channel",RSIPeriod,0,i+2);
                  oscj=iCustom(NULL,0,"IRSI_Channel",RSIPeriod,0,j);
                  break;
               case 2:
                  osc2=iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,0,i+1);
                  oscj=iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,0,j);
                  break;
               default:
                  osc2=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,i+1);
                  oscj=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,j);
                  break;
            }
            Dseparate=osc2-oscj;
            if(((Dchart>0 && Dseparate<0) || (Dchart<0 && Dseparate>0)))
            {
               if(i==0) Up0[i+1]=DnUnits[i+1];
               else Up1[i+1]=DnUnits[i+1];
            }
         }
      }
      i--;
   }
   i=0;
   j=0;
   int n=0;
   while((n==0 || j==0) && (n<Bars-SlowEMA && j<Bars-SlowEMA))
   {
      i++;
      if(n==0 && UpUnits[i]!=0) n=i;
      if(j==0 && DnUnits[i]!=0) j=i;
   }
   if(n!=0)
   {
      Dchart=UpUnits[0]-UpUnits[n];
      switch (SwitchDC)
      {
         case 0:
            osc2=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,0);
            oscj=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,n);
            break;
         case 1:
            osc2=iCustom(NULL,0,"IRSI_Channel",RSIPeriod,0,0);
            oscj=iCustom(NULL,0,"IRSI_Channel",RSIPeriod,0,n);
            break;
         case 2:
            osc2=iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,0,0);
            oscj=iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,0,n);
            break;
         default:
            osc2=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,0);
            oscj=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,n);
            break;
      }
      Dseparate=osc2-oscj;
      if((Dchart>0 && Dseparate<0) || (Dchart<0 && Dseparate>0))
      {
         Dn0[0]=High[0];
      }
   }
   if(j!=0)
   {
      Dchart=DnUnits[0]-DnUnits[j];
      switch (SwitchDC)
      {
         case 0:
            osc2=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,0);
            oscj=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,j);
            break;
         case 1:
            osc2=iCustom(NULL,0,"IRSI_Channel",RSIPeriod,0,0);
            oscj=iCustom(NULL,0,"IRSI_Channel",RSIPeriod,0,j);
            break;
         case 2:
            osc2=iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,0,0);
            oscj=iCustom(NULL,0,"OsTJRSX_Channel",FastJRSX,SlowJRSX,SignalJRSX,0,j);
            break;
         default:
            osc2=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,0);
            oscj=iCustom(NULL,0,"OsIEMA_Channel",FastEMA,SlowEMA,SignalSMA,3,0,j);
            break;
      }
      Dseparate=osc2-oscj;
      if((Dchart>0 && Dseparate<0) || (Dchart<0 && Dseparate>0))
      {
         Up0[0]=Low[0];
      }
   }
   return(0);
}
//+------------------------------------------------------------------+

